%---- stratified resampling ----%
function [newsamples, parents, samp_times] = stratified_resample(samples, weights, N)
% parents is a vector to record the parent of each newsample
% samp_times is a vector to record the number of each sample being...
% resampled.
% (samples, weights) is the empirical distribution to be resampled from.
% N is the number of newsamples wanted.

NN = size(samples,1);  % # of old samples
M = size(samples,2); % dimension of each sample
newsamples = zeros(N,M);
parents = zeros(N,1);
samp_times = zeros(NN,1);

% construct cdf
c(1)=weights(1);
for i=2:1:NN
    c(i)=c(i-1)+ weights(i);
end
i = 1;
u(1) = random('Uniform', 0, 1/N);
for j=1:1:N
    u(j)=u(1) + (j-1)/N;
    while (u(j)>c(i))&&(i<N)
        i = i+1;
    end
    newsamples(j,:) = samples(i,:);
    parents(j) = i;
    samp_times(i) = samp_times(i) + 1;
end